import sys, struct, wave
from cassette import Wave, uart_sincronizer, uart_sync, fsk, manchester, irg_manchester, irg_fsk, zero_crossing

w=Wave(sys.argv[1])

s=w.slice(0)
irgs=list(irg_manchester(s, 30))
print(irgs)

wavef = wave.open(sys.argv[2],'w')
wavef.setnchannels(1)
wavef.setsampwidth(2) 
wavef.setframerate(44100)

pos=0

for i in range(len(irgs)-1):
  start,end=irgs[i]
  nstart=irgs[i+1][0]
  n=end-pos
  wavef.writeframesraw(struct.pack("<h", int(-1.0*16384))*n)
  pos+=n

  j=0
  last_idx=0
  for idx, value in manchester(w.slice(end,nstart), first=1):
    m=0.2 if (j%10)==0 else 0.0 
    wavef.writeframesraw(struct.pack("<h", int(16384*(value+m)))*(idx-last_idx)) # ignore the first, its easier (idx-last_idx==0)
    pos+=(idx-last_idx)
    last_idx=idx
    j=(j+1)%10

wavef.writeframes(b'')
wavef.close()
